## net.sf.saxon.om
Class PrependIterator

    java.lang.Object
      net.sf.saxon.om.PrependIterator

All Implemented Interfaces:
  AxisIterator, SequenceIterator, UnfailingIterator

    public class PrependIterator

extends Object
implements AxisIterator

An iterator over nodes, that prepends a given node to the nodes returned by another iterator. Used to modify an iterator over axis A to one that iterates over A-OR-SELF.

Field Summary

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`PrependIterator(NodeInfo start, AxisIterator base)`

Method Summary
`Value` `atomize()` Return the atomized value of the current node.
`Item` `current()` Get the current item in the sequence.
`SequenceIterator` `getAnother()` Get another iterator over the same sequence of items, positioned at the start of the sequence
`int` `getProperties()` Get properties of this iterator, as a bit-significant integer.
`CharSequence` `getStringValue()` Return the string value of the current node.
`AxisIterator` `iterateAxis(byte axis, NodeTest test)` Return an iterator over an axis, starting at the current node.
`boolean` `moveNext()` Move to the next node, without returning it.
`Item` `next()` Get the next item in the sequence.
`int` `position()` Get the current position

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PrependIterator

    public PrependIterator(NodeInfo start,
                           AxisIterator base)

Method Detail

### moveNext

    public boolean moveNext()

  Move to the next node, without returning it. Returns true if there is a next node, false if the end of the sequence has been reached. After calling this method, the current node may be retrieved using the current() function.

  Specified by:
    `moveNext` in interface `AxisIterator`

### next

    public Item next()

  Get the next item in the sequence.

  Specified by:
    `next` in interface `SequenceIterator`
  Specified by:
    `next` in interface `UnfailingIterator`
  Returns:
    the next Item. If there are no more nodes, return null.

### current

    public Item current()

  Get the current item in the sequence.

  Specified by:
    `current` in interface `SequenceIterator`
  Specified by:
    `current` in interface `UnfailingIterator`
  Returns:
    the current item, that is, the item most recently returned by next()

### position

    public int position()

  Get the current position

  Specified by:
    `position` in interface `SequenceIterator`
  Specified by:
    `position` in interface `UnfailingIterator`
  Returns:
    the position of the current item (the item most recently returned by next()), starting at 1 for the first node

### iterateAxis

    public AxisIterator iterateAxis(byte axis,
                                    NodeTest test)

  Return an iterator over an axis, starting at the current node.

  Specified by:
    `iterateAxis` in interface `AxisIterator`
  Parameters:
    `axis` - the axis to iterate over, using a constant such as `Axis.CHILD`
    `test` - a predicate to apply to the nodes before returning them.
  Throws:
    `NullPointerException` - if there is no current node

### atomize

    public Value atomize()
                  throws XPathException

  Return the atomized value of the current node.

  Specified by:
    `atomize` in interface `AxisIterator`
  Returns:
    the atomized value.
  Throws:
    `NullPointerException` - if there is no current node
    `XPathException`

### getStringValue

    public CharSequence getStringValue()

  Return the string value of the current node.

  Specified by:
    `getStringValue` in interface `AxisIterator`
  Returns:
    the string value, as an instance of CharSequence.
  Throws:
    `NullPointerException` - if there is no current node

### getAnother

    public SequenceIterator getAnother()

  Get another iterator over the same sequence of items, positioned at the start of the sequence

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Specified by:
    `getAnother` in interface `UnfailingIterator`
  Returns:
    a new iterator over the same sequence

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Copyright (C) Michael H. Kay. All rights reserved.